using Microsoft.AspNetCore;
using Microsoft.AspNetCore.Hosting;
using Microsoft.Extensions.Configuration;
using Microsoft.Extensions.Hosting;
using Microsoft.Extensions.Logging;
using NLog.Web;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace Traffic.Api
{
    public class Program
    {
        //Trace	      0	LogTrace()  Logs messages only for tracing purposes for the developers.
        //             Log q`Ω}oqA}oHˬdƨϥΡAi|]t@ǱbKXӷPơAAX]ӥX{bҪ Log C (w]|X)
        
        //Debug       1	LogDebug() Logs messages for short-term debugging purposes. w]|X
        //            o Log OFbҰϥΡA`Ӷ}ҡAקK Log qӤjAϦӷ|yҪDC (w]|X)
        
        //Information 2	LogInformation() Logs messages for the flow of the application.
        //            ` Log ADnO{չB檺y{C
       
        //Warning     3	LogWarning() Logs messages for abnormal or unexpected events in the application flow.
        //            iw~Ϊ̮įणΪƥF藍|AF|nDC
       
        //Error       4	LogError() Logs error messages.
        //            Dw~Aӵoͦoo͡AӭnקKƵoͪ~ƥC
      
        //Critical    5	LogCritical() Logs failures messages that require immediate attention.
        //            unoʹNǳƨWҪ~ƥAҦp|ɭPҡAtαY쪺ƥC
        public static void Main(string[] args)
        {
            // NLog: setup the logger first to catch all errors
            var logger = NLog.Web.NLogBuilder.ConfigureNLog("nlog.config").GetCurrentClassLogger();
            try
            {
                logger.Debug("init main");
                BuildWebHost(args).Build().Run();
            }
            catch (Exception ex)
            {
                //NLog: catch setup errors
                logger.Error(ex, "Stopped program because of exception");
                throw;
            }
            finally
            {
                // Ensure to flush and stop internal timers/threads before application-exit (Avoid segmentation fault on Linux)
                NLog.LogManager.Shutdown();
            }
        }

        public static IWebHostBuilder BuildWebHost(string[] args) =>
            WebHost.CreateDefaultBuilder(args)
                .UseStartup<Startup>()
                .ConfigureLogging(logging =>
                {
                    logging.ClearProviders();
                    logging.SetMinimumLevel(LogLevel.Trace);
                })
                .UseNLog();  // NLog: setup NLog for Dependency injection
    }
}
