﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Text.Json.Serialization;
using System.Threading.Tasks;

namespace Traffic.Data.ViewModels
{
    public class EventViewModel
    {
        [JsonPropertyName("Id")]
        public int Id { get; set; }
        [JsonPropertyName("SiteID")]
        public string SiteID { get; set; }
        [JsonPropertyName("EventID")]
        public string EventID { get; set; }
        [JsonPropertyName("Channel")]
        public string Channel { get; set; }
        [JsonPropertyName("Slot")]
        public string Slot { get; set; }
        [JsonPropertyName("Number")]
        public string Number { get; set; }
        [JsonPropertyName("PlateNumber")]
        public string PlateNumber { get; set; }
        [JsonPropertyName("EventType")]
        public string EventType { get; set; }
        [JsonPropertyName("VehicleType")]
        public string VehicleType { get; set; }
        [JsonPropertyName("VehicleName")]
        public string VehicleName { get; set; }
        [JsonPropertyName("Distance")]
        public string Distance { get; set; }
        [JsonPropertyName("Speed")]
        public string Speed { get; set; }
        [JsonPropertyName("TotalPassTime")]
        public string TotalPassTime { get; set; }
        [JsonPropertyName("LimitTon")]
        public string LimitTon { get; set; }
        [JsonPropertyName("Ton")]
        public string Ton { get; set; }
        [JsonPropertyName("InTime")]
        public string InTime { get; set; }
        [JsonPropertyName("AlarmTime")]
        public string AlarmTime { get; set; }
        [JsonPropertyName("OutTime")]
        public string OutTime { get; set; }
        [JsonPropertyName("LPRTime")]
        public string LPRTime { get; set; }
        [JsonPropertyName("IMGPath1")]
        public string IMGPath1 { get; set; }
        [JsonPropertyName("IMGPath2")]
        public string IMGPath2 { get; set; }
        [JsonPropertyName("IMGPath3")]
        public string IMGPath3 { get; set; }
        [JsonPropertyName("IMGPath4")]
        public string IMGPath4 { get; set; }
        [JsonPropertyName("IMGPath5")]
        public string IMGPath5 { get; set; }
        [JsonPropertyName("IMGPath6")]
        public string IMGPath6 { get; set; }
        [JsonPropertyName("VideoPath1")]
        public string VideoPath1 { get; set; }
        [JsonPropertyName("VideoPath2")]
        public string VideoPath2 { get; set; }
        [JsonPropertyName("IsStay")]
        public string IsStay { get; set; }
        [JsonPropertyName("Unsure")]
        public string Unsure { get; set; }
        [JsonPropertyName("CheckPunish")]
        public string CheckPunish { get; set; }
        [JsonPropertyName("Punished")]
        public string Punished { get; set; }
        [JsonPropertyName("CompanyCode")]
        public string CompanyCode { get; set; }
        [JsonPropertyName("Ps")]
        public string Ps { get; set; }
        [JsonPropertyName("HandlingTime")]
        public string HandlingTime { get; set; }
        [JsonPropertyName("UploadTime")]
        public string UploadTime { get; set; }
        [JsonPropertyName("Rejected")]
        public string Rejected { get; set; }
        [JsonPropertyName("Account")]
        public string Account { get; set; }
    }

    public class EventSearchByNumberViewModel
    {
        [JsonPropertyName("Id")]
        public int Id { get; set; }
        [JsonPropertyName("Number")]
        public string Number { get; set; }
        [JsonPropertyName("SiteName")]
        public string SiteName { get; set; }
        [JsonPropertyName("EventName")]
        public string EventName { get; set; }
        [JsonPropertyName("InTime")]
        public string InTime { get; set; }
        [JsonPropertyName("Status")]
        public string Status { get; set; }
    }

    public class JoinEventSiteAndUserViewModel
    {
        [JsonPropertyName("Id")]
        public int Id { get; set; }
        [JsonPropertyName("UserID")]
        public string UserID { get; set; }
        [JsonPropertyName("County")]
        public string County { get; set; }
        [JsonPropertyName("Area")]
        public string Area { get; set; }
        [JsonPropertyName("SiteId")]
        public string SiteId { get; set; }
        [JsonPropertyName("SiteName")]
        public string SiteName { get; set; }
        [JsonPropertyName("EventName")]
        public string EventName { get; set; }
        [JsonPropertyName("VehicleName")]
        public string VehicleName { get; set; }
        [JsonPropertyName("Laws")]
        public List<LawsCodes> Laws { get; set; }
        [JsonPropertyName("EventID")]
        public string EventID { get; set; }
        [JsonPropertyName("Channel")]
        public string Channel { get; set; }
        [JsonPropertyName("Slot")]
        public string Slot { get; set; }
        [JsonPropertyName("Number")]
        public string Number { get; set; }
        //[JsonPropertyName("PlateNumber")]
        //public string PlateNumber { get; set; }
        [JsonPropertyName("EventType")]
        public string EventType { get; set; }
        [JsonPropertyName("VehicleType")]
        public string VehicleType { get; set; }
        [JsonPropertyName("Distance")]
        public string Distance { get; set; }
        [JsonPropertyName("Speed")]
        public string Speed { get; set; }
        [JsonPropertyName("TotalPassTime")]
        public string TotalPassTime { get; set; }
        [JsonPropertyName("LimitTon")]
        public string LimitTon { get; set; }
        [JsonPropertyName("Ton")]
        public string Ton { get; set; }
        [JsonPropertyName("InTime")]
        public string InTime { get; set; }
        [JsonPropertyName("AlarmTime")]
        public string AlarmTime { get; set; }
        [JsonPropertyName("OutTime")]
        public string OutTime { get; set; }
        [JsonPropertyName("LPRTime")]
        public string LPRTime { get; set; }
        [JsonPropertyName("IMGPath1")]
        public string IMGPath1 { get; set; }
        //[JsonPropertyName("IMGPath2")]
        //public string IMGPath2 { get; set; }
        //[JsonPropertyName("IMGPath3")]
        //public string IMGPath3 { get; set; }
        //[JsonPropertyName("IMGPath4")]
        //public string IMGPath4 { get; set; }
        //[JsonPropertyName("IMGPath5")]
        //public string IMGPath5 { get; set; }
        //[JsonPropertyName("IMGPath6")]
        //public string IMGPath6 { get; set; }
        [JsonPropertyName("IMGList")]
        public List<string> IMGList { get; set; }
        [JsonPropertyName("VideoPath1")]
        public string VideoPath1 { get; set; }
        //[JsonPropertyName("VideoPath2")]
        //public string VideoPath2 { get; set; }
        [JsonPropertyName("Video")]
        public List<string> VideoList { get; set; }
        [JsonPropertyName("IsStay")]
        public string IsStay { get; set; }
        [JsonPropertyName("Unsure")]
        public string Unsure { get; set; }
        [JsonPropertyName("CheckPunish")]
        public string CheckPunish { get; set; }
        [JsonPropertyName("Punished")]
        public string Punished { get; set; }
        [JsonPropertyName("CompanyCode")]
        public string CompanyCode { get; set; }
        [JsonPropertyName("Rejected")]
        public string Rejected { get; set; }
        [JsonPropertyName("Status")]
        public string Status { get; set; }
        [JsonPropertyName("Ps")]
        public string Ps { get; set; }
        [JsonPropertyName("HandlingTime")]
        public string HandlingTime { get; set; }
        [JsonPropertyName("UploadTime")]
        public string UploadTime { get; set; }
        [JsonPropertyName("Account")]
        public string Account { get; set; }
    }

    public class LawsCodes
    { 
        public string LawsCode { get; set; }
    }
}
