﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net.Mail;
using System.Text;
using System.Threading.Tasks;

namespace Traffic.Data.ViewModels
{
    public class MailViewModel
    {
        /// <summary>
        /// 寄件者
        /// </summary>
        public string From { get; set; }

        /// <summary>
        /// 收件者
        /// </summary>
        public string[] To { get; set; }

        /// <summary>
        /// 主旨
        /// </summary>
        public string Subject { get; set; }

        /// <summary>
        /// 主旨 Encoding (System.Text.Encoding.UTF8)
        /// </summary>
        public Encoding SubjectEncoding { get; set; }

        /// <summary>
        /// 內文
        /// </summary>
        public string Body { get; set; }

        /// <summary>
        /// 內文是否為Html
        /// </summary>
        public bool IsBodyHtml { get; set; }

        /// <summary>
        /// 內文 Encoding (System.Text.Encoding.UTF8)
        /// </summary>
        public Encoding BodyEncoding { get; set; }

        /// <summary>
        /// 郵件的優先度
        /// </summary>
        public MailPriority Priority { get; set; }
    }
}
