﻿using System;
using Traffic.Repository.Interfaces;

namespace Traffic.Repository.Infrastructures
{
    public interface IUnitOfWork : IDisposable
    {
        IAccountRepository AccountRepository { get; }
        ICompanyInformationRepository CompanyInformationRepository { get; }
        IEventTypeRepository EventTypeRepository { get; }
        IPoliceStationRepository PoliceStationRepository { get; }
        IAnnounceRepository AnnounceRepository { get; }
        IRolePageRepository RolePageRepository { get; }
        INotPunishRepository NotPunishRepository { get; }
        ISiteInformationRepository SiteInformationRepository { get; }
        IEventRepository EventRepository { get; }
        IMalfunctionRepository MalfunctionRepository { get; }
        ITycgRepository TycgRepository { get; }
        IRepairRepository RepairRepository { get; }
        void Complete();
        void Rollback();
    }
}
