﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Traffic.Data.Models;
using Traffic.Data.ViewModels;

namespace Traffic.Repository.Interfaces
{
    public interface IEventRepository
    {
        public int GetEventCount(string term);
        public int GetEventBySitesCount(string siteId, string term);
        public int GetEventJoinSiteAndUsersCount(int userId, string eventType, string startTime, string endTime);
        public IEnumerable<Event> GetEvents();
        public IEnumerable<Event> GetEventsByCar(string term);
        public IEnumerable<Event> GetEventBySites(string siteId, int page, int pageSize);
        public IEnumerable<JoinEventSite> GetEventBySitesAndEventType(List<string> sitesId, List<string> eventTypes, string startTime, string endTime);
        public IEnumerable<Event> GetEventByEventType(string eventType, int page, int pageSize);
        public int GetEventByTimeCount(string startTime, string endTime);
        public IEnumerable<Event> GetEventByTime(string startTime, string endTime);
        public IEnumerable<VehicleTypeTable> GetVehicleType();
        //public IEnumerable<JoinEventSiteAndUser> GetEventJoinSiteAndUsers(int userid, string eventType, string startTime, string endTime);
        public IEnumerable<JoinEventSiteAndUser> GetEventJoinSiteAndUsers(int userId, string eventType, string startTime, string endTime);
        public IEnumerable<Event> GetEvents(string startDatetime, string endDatetime);
        public Event GetEventById(int id);
        public VehicleTypeTable GetVehicleTypebyType(string vehicletype);
        public int GetThisYearEventsCount(string startTime, string endTime, string account);
        public int GetThisMonthEventsCount(string startTime, string endTime, string account);
        public int GetEventByEventTypeCount(string eventType);
        public bool InsertEvent(Event data);
        public bool UpdateEvent(Event data);
        public bool UpdatEventCheckPunish(string account, int eventId, string checkPunish, string law);
        public bool UpdatEventNoPunish(string account, int eventId, string ps);
        public bool UpdateEventVehicleType(int id, string vehicleType);
        public bool UpdateEventVehicleNumber(int id, string vehicleNumber);
        public bool UpdateEventVehicle(int id, string vehicleType, string vehicleNumber);
        public bool DeleteEvent(int id);
        public IEnumerable<ExceptionNumber> GetExceptionNumbers();
    }
}
