﻿using Microsoft.AspNetCore.Mvc.Filters;
using Microsoft.Extensions.Logging;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;

namespace Traffic.Service.Filter
{
    public class LogFilter : IActionFilter
    {
        private readonly ILogger _logger;
        public LogFilter(ILogger<LogFilter> logger)
        {
            _logger = logger;
        }

        public void OnActionExecuting(ActionExecutingContext context)
        {
            // Do something before the action executes.
            _logger.LogDebug($"{MethodBase.GetCurrentMethod()}{context.HttpContext.Request.Path}");
        }

        public void OnActionExecuted(ActionExecutedContext context)
        {            
            // Do something before the action executes.
            _logger.LogDebug($"{MethodBase.GetCurrentMethod()}{context.HttpContext.Request.Path}");
        }
    }
}
