﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Traffic.Data.ViewModels;

namespace Traffic.Service.Interfaces
{
    public interface IEventService
    {
        public PageViewModel<IEnumerable<EventSearchByNumberViewModel>> GetEventsByCar(SearchModel searchModel);

        public PageViewModel<IEnumerable<EventViewModel>> GetEventBySites(string id, SearchModel model);

        public PageViewModel<IEnumerable<JoinEventSiteAndUserViewModel>> GetEventByEventType(int userId, string eventType, SearchModel searchModel);

        public IEnumerable<JoinEventSiteAndUserViewModel> GetEventsByEventType(int id, string eventType, string startTime, string endTime, string site, string status, string time, string speed);
        
        public EventViewModel GetEventById(int id);

        public int GetThisYearEventsCount(string account);

        public int GetThisMonthEventsCount(string account);

        public EventCountViewModel GetEventsCount(string startDatetime, string endDatetime);

        public TradeResultModel InsertEvent(EventViewModel Event);

        public TradeResultModel UpdatEvent(int id, EventViewModel Event);

        public TradeResultModel UpdatEventCheckPunish(string account, int eventId, string checkPunish, string law);

        public TradeResultModel UpdatEventCheckPunishList(string account, List<int> eventId, string checkPunish, string law);

        public TradeResultModel UpdatEventNoPunish(string account, int eventId, string reason);

        public TradeResultModel UpdatEventCancel(string account, int id);

        public TradeResultModel UpdatEventVehicleType(int id, string vehicleType);

        public TradeResultModel UpdatEventVehicleNumber(int id, string vehicleNumber);

        public TradeResultModel DeleteEvent(int id);

        public TradeResultModel UpdatEventVehicle(int id, string vehicleType, string vehicleNumber);

        public IEnumerable<VehicleTypeViewModel> GetVehicleTypes();
    }
}
